// Illustration of very simple inheritance hierarchy of Animals and
// single dynamic dispatch.  Each class descends from Animal and
// overrides the proclaim() method.
class Animal{ 
  public String myName;
  public Animal(){
    
  }
  public void proclaim(String s){ 
    System.out.println(s); 
  }
}
// Humans can talk due to certain organs
class Human extends Animal {
  public void proclaim(String s){ 
    System.out.println(s+" (thank you big brain)");
  }
}
// Mice can't
class Mouse extends Animal {
  public void proclaim(String s){
    System.out.println("squeak (Mice can't talk)");
  }
}
// Snakes end with a hissssss
class Snake extends Animal {
  public void proclaim(String s){
    System.out.println(s+"ssss..");
  }
}
// Ducks quck rather than talk
class Duck extends Animal {
  public void proclaim(String s){
    System.out.println("quack");
  }
}
// Unless the duck is a mascot in which case the duck will append a
// corporate logo
class Mascot extends Duck {
  public void proclaim(String s){
    System.out.println(s+" ... Aflack!");
  }
}
class Tiger extends Animal {
  public void proclaim(String s){
    System.out.println("ROOOOAR! ("+s+")");
  }
    
}

// Main class to demonstrate
public class Animals{ 
  public static void main(String args[]){
    // Any kind of Animal can be in an Animal array
    Animal animals[] = new Animal[]{
      new Animal(),
      new Human(),
      new Mouse(),
      new Snake(),
      new Duck(),
      new Mascot(),
      new Tiger(),
    };
    // For every animal a in the array animals
    for(Animal a : animals){
      a.proclaim("How do you do?"); // Watch what is said
      // System.out.println(a.toString());
    }
  }
}
