// Illustration that java does not have double dispatch, only single
// dispatch via method calls.  Having double-dynamic dispatch would
// make the below code extremely easy to understand whereas at present
// in java, figuring out what happens when animal X meets animal Y is
// a hard thing to code.
class Animal{ }
class Mouse  extends Animal {}
class Snake  extends Animal {}
class Duck   extends Animal {}
class Mascot extends Duck {}

public class DoubleDispatch{ 
  // No dynamic dispatch is done on the meets() method
  public static void meets(Animal x, Animal y){
    System.out.println("Nothing special");
  }
  public static void meets(Snake x, Mouse y){
    System.out.println("Snake eats mouse");
  }
  public static void meets(Mouse x, Snake y){
    System.out.println("Mouse runs away");
  }
  public static void meets(Snake x, Duck y){
    System.out.println("Snake eats duck, ruptures stomach, dies");
  }
  public static void meets(Duck x, Snake y){
    System.out.println("Duck flies away");
  }
  public static void meets(Mascot x, Animal y){
    System.out.println("Mascot sells animal insurance");
  }
  public static void main(String args[]){
    Animal animals[] = new Animal[]{
      new Animal(),
      new Snake(),
      new Duck(),
      new Mascot()
    };
    // Determine what happens when one animal meets another; does not
    // run as one might expect or want
    for(int i=0; i<animals.length-1; i++){
      for(int j=i+1; j<animals.length; j++){
        Animal x=animals[i], y=animals[j];
        meets(x,y);
      }
    }
  }
}
