// This file demonstrates how a child class can shadow the name of a
// parent class field.

// Simple parent with a single field
class Parent {
  protected int field;
  public Parent(int f){
    this.field = f;
  }
  public void reportField(){
    System.out.println(field);  // field binds to this.field
  }
}

class ProperChild extends Parent{
  public ProperChild(int f){
    super(f);
  }
  public void anotherReport(){
    System.out.println(field);  // field binds to super.field
  }
}

class ShadyChild extends Parent{
  protected int field;          // Who knows what evil lurks in the hearts of men...
  public ShadyChild(int f){
    super(f);
    this.field = 2*f;
  }
  public void anotherReport(){
    System.out.println(field);  // Where does field bind?
  }
}

public class Shadowing{
  public static void main(String args[]){
    Parent p = new Parent(1);
    p.reportField();            // 1

    ProperChild pc = new ProperChild(2);
    pc.reportField();           // 2
    pc.anotherReport();         // 2

    ShadyChild sc = new ShadyChild(3);
    sc.reportField();           // 3
    sc.anotherReport();         // 6 ?!?
  }
}
